package com.boe.zxy.interfacePlat.config;

import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import tk.mybatis.spring.annotation.MapperScan;

import javax.sql.DataSource;

/**
 * @project interfacePlat
 * @description
 * @author 10539622
 * @date 2023/8/27 16:19
 * @version 1.0
 */
@Configuration
@MapperScan(basePackages = "com.boe.zxy.interfacePlat.mapper.fm",sqlSessionFactoryRef = "SqlSessionFactory")
public class DataSourceConfig {
    @Bean(name = "DataSource")
    //@Primary
    @ConfigurationProperties("spring.datasource")
    public DataSource bDataSource() {
        return DataSourceBuilder.create().build();
    }

    @Bean(name = "SqlSessionFactory")
    //@Primary
    public SqlSessionFactory sqlSessionFactory(@Qualifier("DataSource") DataSource dataSource) throws Exception {
        SqlSessionFactoryBean sessionFactoryBean = new SqlSessionFactoryBean();
        sessionFactoryBean.setDataSource(dataSource);
        sessionFactoryBean.setMapperLocations(new PathMatchingResourcePatternResolver()
                .getResources("classpath*:mapper/fm/*.xml"));
        return sessionFactoryBean.getObject();
    }

    @Bean(name = "TransactionManager")
    //@Primary
    public DataSourceTransactionManager TransactionManager() {
        return new DataSourceTransactionManager(bDataSource());
    }
}