package com.boe.zxy.interfacePlat.service;

import com.boe.zxy.interfacePlat.entity.*;
import com.boe.zxy.interfacePlat.mapper.sdk.*;
import com.boe.zxy.interfacePlat.util.mail.JavaMailUntil;
import jxl.Workbook;
import jxl.write.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.*;
import javax.mail.internet.*;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * @project interfacePlat
 * @description
 * @author 10539622
 * @date 2023/8/27 19:44
 * @version 1.0
 */
@Slf4j
@Service
public class AsyncRemoteDataService {



    @Autowired
    MailSend mailSend;



    /**
     * @description TODO 分批出库邮件
     * No such property: code for class: Script1
     * @return
     * @author 10539622
     * @date 2023/9/4 9:56
     */
    @Async
    public void SendAgeInfpMail() throws MessagingException, IOException {
        //获取带发送信息
        List<BeanAgeInfo> ageInfo = mailSend.getAgeInfo();
        if (ageInfo == null || ageInfo.size() <= 0) return;
        //获取发送邮件是否开启
        List<BeanEmail> preStockOutInfo1 = mailSend.getSendEmailType("AgeInfo");
        if (preStockOutInfo1 == null || preStockOutInfo1.size() <= 0) return;
        //获取收件人信息
        List<BeanEmail> preStockOutInfo2 = mailSend.getSendEmailReceiver("AgeInfo");
        if (preStockOutInfo2 == null || preStockOutInfo2.size() <= 0) return;

        Session session = JavaMailUntil.createSession();

//	创建邮件对象
        MimeMessage message = new MimeMessage(session);
        message.setSubject("即将过期物料提醒");

        
        StringBuffer mailText = new StringBuffer();
        mailText.append("<table width='100%'>");
        mailText.append("<tr height='30px'>");
        mailText.append("<td align='left' width='30%'>您好！<br/><br/></td>");
        mailText.append("</tr>");
        mailText.append("<tr>");
        mailText.append("<td align='left' width='30%'>目前有以下物料即将到期<br/><br/></td>");
        mailText.append("</tr>");
//        mailText.append("<tr><td>");
//        mailText.append("<table border='1' width='100%' style='text-align:center;border-collapse: collapse;border: none;border: solid #000 1px;'>");
//        mailText.append("<tr>");
//        mailText.append("<td width='5%'>序号</td><td width='10%'>料号</td><td width='10%'>名称</td><td width='10%'>型号</td><td width='10%'>批次</td>");
//        mailText.append("<td width='10%'>供应商</td><td width='10%'>制造日期</td><td width='10%'>过日期</td>");
//        mailText.append("<td width='10%'>仓库</td><td width='5%'>数量</td><td width='5%'>单位</td><td width='5%'>剩余天数</td>");
//        mailText.append("</tr>");

        if(ageInfo != null && !ageInfo.isEmpty())
//            for(int i = 0 ; i<ageInfo.size(); i++){
//                BeanAgeInfo beanPreStockOutInfo = ageInfo.get(i);
//
//                mailText.append("<tr><td>" + (i+1) + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getMATERIALSPECNAME() != null&& !"".equals(beanPreStockOutInfo.getMATERIALSPECNAME()) ? beanPreStockOutInfo.getMATERIALSPECNAME() : " ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getDESC_CN() !=null&&!"".equals(beanPreStockOutInfo.getDESC_CN())?beanPreStockOutInfo.getDESC_CN():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getMDESCRIPTION() !=null&&!"".equals(beanPreStockOutInfo.getMDESCRIPTION())?beanPreStockOutInfo.getMDESCRIPTION():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getCHARGE() !=null&&!"".equals(beanPreStockOutInfo.getCHARGE())?beanPreStockOutInfo.getCHARGE():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getSUPPLIERNAME()!=null&&!"".equals(beanPreStockOutInfo.getSUPPLIERNAME())?beanPreStockOutInfo.getSUPPLIERNAME():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getMAKEDATE() != null&&!"".equals(beanPreStockOutInfo.getMAKEDATE())?beanPreStockOutInfo.getMAKEDATE():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getEXPIRINGDATE() != null&&!"".equals(beanPreStockOutInfo.getEXPIRINGDATE())?beanPreStockOutInfo.getEXPIRINGDATE():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getDESCRIPTION() != null&&!"".equals(beanPreStockOutInfo.getDESCRIPTION())?beanPreStockOutInfo.getDESCRIPTION():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getQTY() != null&&!"".equals(beanPreStockOutInfo.getQTY())?beanPreStockOutInfo.getQTY():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getUNIT() != null&&!"".equals(beanPreStockOutInfo.getUNIT())?beanPreStockOutInfo.getUNIT():" ") + "</td>");
//                mailText.append("<td>" + (beanPreStockOutInfo.getZAGE() != null&&!"".equals(beanPreStockOutInfo.getZAGE())?beanPreStockOutInfo.getZAGE():" ") + "</td>");
//
//            }
        mailText.append("</table>");
        mailText.append("</td>");
        mailText.append("</tr>");
        mailText.append("<tr><td></td></tr>");
        mailText.append("</table>");
        //message.setText(mailText.toString());
        message.setFrom(new InternetAddress("wms@sidike.com"));

//        message.setFrom(new InternetAddress("17868840037@163.com"));
//        message.setRecipient(Message.RecipientType.TO, new InternetAddress("lixinghui-b7@boe.com.cn"));
//        message.setRecipient(Message.RecipientType.TO, new InternetAddress("wangsichen@boe.com.cn"));
        
        String[] receiverList= preStockOutInfo2.get(0).getReceiver().split(",");
        Address[] addresses = new Address[receiverList.length];
        for (int i = 0; i < receiverList.length ; i++) {
            addresses[i] = new InternetAddress(receiverList[i]);
        }
        message.setRecipients(Message.RecipientType.TO,addresses);
        //生成excel附件
        Date sendDate = new Date(); // mail send time
        String fs = System.getProperties().getProperty("file.separator");
        String property = System.getProperty("os.name");
        String fileUrl = "";
        if ("Windows".equals(property)) {
            fs = "D:" + fs;
        }
        JavaMailUntil.createDir(fs + "home" + fs + "ziwms" + fs + "attachment");
        String fileName = "材料寿命 "  + new SimpleDateFormat("yyyyMMddHHmmsss").format(sendDate) + ".xls";
        fileUrl = fs + "home" + fs + "ziwms" + fs + "attachment" + fs + fileName;

        // 生成excel
        FileOutputStream fout;
        try {
            fout = new FileOutputStream(fileUrl);
            createPreStockOutExcel(ageInfo, fout);
            Multipart mainPart = new MimeMultipart();
            // 创建一个包含HTML内容的MimeBodyPart
            BodyPart html = new MimeBodyPart();
            html.setContent(mailText.toString(), "text/html; charset=utf-8");
            mainPart.addBodyPart(html);
            message.setContent(mainPart);

            html = new MimeBodyPart();
            String s = MimeUtility.decodeText(fileName);
            html.setFileName(s);
           // html.setDataHandler(new DataHandler(new ByteArrayDataSource(Files.readAllBytes(Paths.get("D:"+ fs + "attachment")),"application/octet-stream")));

            DataSource source = new FileDataSource(fileUrl);
            //设置附件的数据处理器
            html.setDataHandler(new DataHandler(source));
            // 设置HTML内容     建立第一部分： 文本正文
            //html.setContent(mailText.toString(), "text/html; charset=utf-8");
            mainPart.addBodyPart(html);
            // 将MiniMultipart对象设置为邮件内容   建立第二部分：附件

            Transport.send(message);
        } catch (Exception e) {
            e.printStackTrace();
        }
//	发送

    }



    /**
     * @description TODO
     * No such property: code for class: Script1
     * @return
     * @author 10539622
     * @date 2023/9/4 17:34
     */
    public void createPreStockOutExcel(List<BeanAgeInfo> sqlResult, OutputStream os)
            throws WriteException, IOException {
        WritableWorkbook workbook = Workbook.createWorkbook(os);

        WritableSheet sheet = workbook.createSheet("First Sheet", 0);

        sheet.mergeCells(0, 0, 11, 0);// 添加合并单元格，第一个参数是起始列，第二个参数是起始行，第三个参数是终止列，第四个参数是终止行
        WritableFont bold = new WritableFont(WritableFont.ARIAL, 10, WritableFont.BOLD);// 设置字体种类和黑体显示,字体为Arial,字号大小为10,采用黑体显示
        WritableCellFormat titleFormate = new WritableCellFormat(bold);// 生成一个单元格样式控制对象
        titleFormate.setVerticalAlignment(jxl.format.VerticalAlignment.TOP);// 单元格的内容垂直方向居中
        titleFormate.setWrap(true);
        sheet.addCell(new Label(0, 0, "您好！\n\n目前有以下材料寿命即将到期\n", titleFormate));

        sheet.setRowView(0, 1000, false);

        sheet.addCell(new Label(0, 1, "序号"));
        sheet.addCell(new Label(1, 1, "料号"));
        sheet.addCell(new Label(2, 1, "名称"));
        sheet.addCell(new Label(3, 1, "型号"));
        sheet.addCell(new Label(4, 1, "批号"));
        sheet.addCell(new Label(5, 1, "供应商"));
        sheet.addCell(new Label(6, 1, "制造日期"));
        sheet.addCell(new Label(7, 1, "过期日"));
        sheet.addCell(new Label(8, 1, "ERP库位"));
        sheet.addCell(new Label(9, 1, "数量"));
        sheet.addCell(new Label(10, 1, "单位"));
        sheet.addCell(new Label(11, 1, "剩余天数"));

        if (sqlResult != null && !sqlResult.isEmpty())
            for (int i = 0; i < sqlResult.size(); i++) {
                BeanAgeInfo tmp = sqlResult.get(i);

                sheet.addCell(new Label(0, 2 + i, (i + 1) + ""));
                sheet.addCell(new Label(1, 2 + i,
                        (tmp.getMATERIALSPECNAME() != null ? tmp.getMATERIALSPECNAME().toString() : "")));
                sheet.addCell(new Label(2, 2 + i,
                        (tmp.getDESC_CN() != null ? tmp.getDESC_CN().toString() : "")));
                sheet.addCell(new Label(3, 2 + i,
                        (tmp.getMDESCRIPTION() != null ? tmp.getMDESCRIPTION().toString() : "")));
                sheet.addCell(new Label(4, 2 + i, (tmp.getCHARGE() != null ? tmp.getCHARGE().toString() : "")));
                sheet.addCell(new Label(5, 2 + i,
                        (tmp.getSUPPLIERNAME() != null ? tmp.getSUPPLIERNAME().toString() : "")));
                sheet.addCell(
                        new Label(6, 2 + i, (tmp.getMAKEDATE() != null ? tmp.getMAKEDATE().toString() : "")));
                sheet.addCell(
                        new Label(7, 2 + i, (tmp.getEXPIRINGDATE() != null ? tmp.getEXPIRINGDATE().toString() : "")));
                sheet.addCell(
                        new Label(8, 2 + i, (tmp.getDESCRIPTION() != null ? tmp.getDESCRIPTION().toString() : "")));
                sheet.addCell(
                        new Label(9, 2 + i, (tmp.getQTY() != null ? tmp.getQTY().toString() : "")));
                sheet.addCell(new Label(10, 2 + i, (tmp.getUNIT() != null ? tmp.getUNIT().toString() : "")));
                sheet.addCell(new Label(11, 2 + i, (tmp.getZAGE() != null ? tmp.getZAGE().toString() : "")));
            }
        // 把创建的内容写入到输出流中，并关闭输出流
        workbook.write();
        workbook.close();
        os.close();

    }
    /**
     * @description TODO 
     * No such property: code for class: Script1       
     * @return 过期自动Hold
     * @author 10539622
     * @date 2023/11/15 10:15
     */
    @Async
    public void auToHold() {
        mailSend.AutoHold();
    }

}
