package com.boe.zxy.interfacePlat.service;

/**
 * @Description TODO
 * @Author li
 * @Date 2024/12/23 13:45
 */


import com.boe.zxy.interfacePlat.entity.BeanQMS;
import com.boe.zxy.interfacePlat.entity.BeanQMToERP;
import com.boe.zxy.interfacePlat.mapper.sdk.QMSSend;
import com.boe.zxy.interfacePlat.util.http.BatchProcessorToERPUtil;
import com.boe.zxy.interfacePlat.util.http.BatchProcessorToQMSUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Slf4j
@Service
public class QMSService {

    @Autowired
    QMSSend qmsSend;

    @Autowired
    BatchProcessorToQMSUtil batchProcessorUtil;

    @Autowired
    BatchProcessorToERPUtil batchProcessorERPUtil;

    public void sendQms() {
        List<BeanQMS> preToQMS = qmsSend.getPreToQMS();

        batchProcessorUtil.processDataInBatches(preToQMS,200,null);

        qmsSend.updateQMSflag();

    }

    @Transactional
    public void sendQmToERP() {
        List<BeanQMToERP> preToQMS = qmsSend.getQMSInfoToERP();

        batchProcessorERPUtil.processDataInBatches(preToQMS,200,null);

        qmsSend.updateQMSflagToERP();

    }




}