package com.boe.zxy.interfacePlat.util;

import com.alibaba.druid.util.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @Description TODO
 * @Author li
 * @Date 2024/12/23 15:55
 */
public class TimeStampUtil {
    public static final String FORMAT_TIMEKEY = "yyyyMMddHHmmssSSSSSS";
    public static final String FORMAT_DETAIL = "yyyy-MM-dd HH:mm:ss.SSS";
    public static final String FORMAT_DEFAULT = "yyyy-MM-dd HH:mm:ss";
    public static final String FORMAT_DAY = "yyyy-MM-dd";
    public static final String FORMAT_SIMPLE_DETAIL = "yyyyMMddHHmmssSSS";
    public static final String FORMAT_SIMPLE_DEFAULT = "yyyyMMddHHmmss";
    public static final String FORMAT_SIMPLE_DAY = "yyyyMMdd";
    private static Log log = LogFactory.getLog(TimeStampUtil.class);

    public TimeStampUtil() {
    }

    public static String getCurrentEventTimeKey() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSSSSS");
        return sdf.format(System.currentTimeMillis());
    }

    public static String getEventTimeKeyFromTimestamp(Timestamp timestamp) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSSSSS");
        return sdf.format(timestamp);
    }

    public static String getCurrentTime() {
        long t = System.currentTimeMillis();
        Timestamp st = new Timestamp(t);
        return st.toString();
    }

    public static String getCurrentTime(String format) {
        long t = System.currentTimeMillis();
        Timestamp date = new Timestamp(t);
        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(date);
    }

    public static Timestamp getCurrentTimestamp() {
        long t = System.currentTimeMillis();
        return new Timestamp(t);
    }

    public static String toTimeString(Timestamp timestamp) {
        return toTimeString(timestamp, "yyyy-MM-dd HH:mm:ss");
    }

    public static String toTimeString(Timestamp timestamp, String format) {
        if (timestamp == null) {
            timestamp = getCurrentTimestamp();
        }

        if (StringUtils.isEmpty(format)) {
            format = "yyyy-MM-dd HH:mm:ss";
        }

        SimpleDateFormat sdf = new SimpleDateFormat(format);
        return sdf.format(timestamp);
    }

    public static Timestamp getTimestamp(String time) {
        try {
            SimpleDateFormat sdf = null;
            if (time.length() > 20) {
                sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
            } else if (time.length() == 20) {
                sdf = new SimpleDateFormat("yyyyMMddHHmmssSSSSSS");
            } else if (time.length() == 19) {
                sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            } else if (time.length() == 17) {
                sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
            } else if (time.length() == 14) {
                sdf = new SimpleDateFormat("yyyyMMddHHmmss");
            } else if (time.length() == 10) {
                sdf = new SimpleDateFormat("yyyy-MM-dd");
            } else {
                if (time.length() != 8) {
                    log.warn("could not create Timestamp : " + time);
                    return null;
                }

                sdf = new SimpleDateFormat("yyyyMMdd");
            }

            Date date = sdf.parse(time);
            return new Timestamp(date.getTime());
        } catch (Exception var3) {
            return null;
        }
    }
}