package com.boe.zxy.interfacePlat.util.http;

import com.alibaba.fastjson.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
 

/**
 * 
 * @author 10539622
 *
 */
@Service
public class FMHttpUtil {
 
    @Autowired
    private static RestTemplate restTemplate;
    
    static {
    	if (restTemplate == null) {
    		restTemplate = new RestTemplate();
    	}
    }
 
    private static String  access_token = "";
    
    private static String baseUrl = "http://202.101.116.87:8022/";
    private static String appId = "WMS";
    private static String appSecuret = "Wms@20230419123456789.";
    private static String tenantid = "达华2303";
    private static String accountId = "1705718807168811008";
    private static String user = "17868840037";
    
	static {
		String mode = System.getProperty("mode");
		if ("PRD".equals(mode)) {
			baseUrl = "http://202.101.116.88:8022/";
			appId = "WMS";
			appSecuret = "Wms@20230419123456789.";
			tenantid = "达华";
			accountId = "1557314466603859968";
			user = "18905908070";
		}
	}

    
	// 获取apptoken
	public static String httpPostapptoken(String requestUrl) {
		StringBuffer buffer = null;
		String result = "";
		String app_token = "";
		try {
			URL url = new URL(requestUrl);
			HttpURLConnection conn = (HttpURLConnection) url.openConnection();
			conn.setReadTimeout(800000000);
			conn.setConnectTimeout(80000000);
			conn.setRequestMethod("POST");
			conn.setDoOutput(true);
			conn.setDoInput(true);
			conn.setRequestProperty("Content-Type", "application/json;charset=UTF-8");
			conn.connect();
			OutputStreamWriter writer = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
			// body参数在这里put到JSONObject中
			JSONObject parm = new JSONObject();
			parm.put("appId", appId);
			parm.put("appSecuret", appSecuret);
			parm.put("tenantid", tenantid);
			parm.put("accountId", accountId);
			parm.put("language", "zh_CN");
			writer.write(parm.toString());
			writer.flush();
			// 读取服务器端返回的内容
			java.io.InputStream is = conn.getInputStream();
			InputStreamReader isr = new InputStreamReader(is, "utf-8");
			BufferedReader br = new BufferedReader(isr);

			buffer = new StringBuffer();
			String line = null;
			while ((line = br.readLine()) != null) {
				result += line;
				buffer.append(line);
			}
			JSONObject buffers = JSONObject.parseObject(result);
			Object token = ((JSONObject) buffers.get("data")).get("app_token");
			app_token = (String) token;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return app_token;
	}

	// 获取access_token
	public static String httpPostaccesstoken(String requestUrl, String apptoken) {
		StringBuffer buffer = null;
		String result = "";
		
		try {
			URL url = new URL(requestUrl);
			HttpURLConnection conn = (HttpURLConnection) url.openConnection();
			conn.setRequestMethod("POST");
			conn.setDoOutput(true);
			conn.setDoInput(true);
			conn.setReadTimeout(800000000);
			conn.setConnectTimeout(80000000);
			conn.setRequestProperty("Content-Type", "application/json;charset=UTF-8");
			conn.connect();
			OutputStreamWriter writer = new OutputStreamWriter(conn.getOutputStream(), "UTF-8");
			// body参数在这里put到JSONObject中
			JSONObject parm = new JSONObject();
			/*
			 * http://192.168.90.104:8022/ierp/api/login.do {     "user":"18960635625",
			 *     "apptoken":"",     "tenantid":"达华2303",
			 *     "accountId":"1635349323770232832",     "usertype":"Mobile" }
			 */
			parm.put("user", user);// 手机
			parm.put("apptoken", apptoken);
			parm.put("tenantid", tenantid);
			parm.put("accountId", accountId);
			parm.put("usertype", "Mobile");
			writer.write(parm.toString());
			writer.flush();
			// 读取服务器端返回的内容
			java.io.InputStream is = conn.getInputStream();
			InputStreamReader isr = new InputStreamReader(is, "utf-8");
			BufferedReader br = new BufferedReader(isr);

			buffer = new StringBuffer();
			String line = null;
			while ((line = br.readLine()) != null) {
				result += line;
				buffer.append(line);
			}
			JSONObject buffers = JSONObject.parseObject(result);
			Object token = ((JSONObject) buffers.get("data")).get("access_token");
			access_token = (String) token;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return access_token;
	}
    
    /**
     * exchange
     * @return
     * @throws Exception
     */
    public String doExchange(String url, JSONObject jso) throws Exception {
    	String body = "";
    	try {
    		String appToken = httpPostapptoken(baseUrl + "ierp/api/getAppToken.do");
        	if (appToken == null || "".equals(appToken)) return null;
        	String acessToken = httpPostaccesstoken(baseUrl + "ierp/api/login.do", appToken);
            //header参数
            HttpHeaders headers = new HttpHeaders();
            headers.add("accessToken", acessToken);
            headers.setContentType(MediaType.APPLICATION_JSON);
            //组装
            HttpEntity<JSONObject> request = new HttpEntity<>(jso, headers);
           
            ResponseEntity<String> responseEntity = restTemplate.exchange(url, HttpMethod.POST, request, String.class);
             body = responseEntity.getBody();
    	} catch (Exception e) {
    		e.toString();
    		throw new Exception(e.toString());
    	}
    	
        return body;
    }
}
