package com.boe.zxy.interfacePlat.util.http;

import com.boe.zxy.interfacePlat.entity.ErpMessageLog;
import com.boe.zxy.interfacePlat.mapper.sdk.MakeLog;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.concurrent.LinkedBlockingQueue;

/**
 * @Description TODO
 * @Author li
 * @Date 2024/12/23 15:50
 */
public class MessageLogUtil {

    @Autowired
    MakeLog makeLog;

    private static Logger log = LoggerFactory.getLogger(MessageLogUtil.class);
    private static MessageLogUtil messageLogUtil = new MessageLogUtil();
    private static MessageLogUtil.MessageLogWriter messageLogWriter = messageLogUtil.new MessageLogWriter();
    static {
        Thread messageLogThread = new Thread(messageLogWriter);
        messageLogThread.setDaemon(true);
        messageLogThread.setName("MESSAGELOGGING");
        messageLogThread.start();
    }
    public  void writeMessageLog(ErpMessageLog erpMessageLog) {
        messageLogWriter.getQueue().offer(erpMessageLog);
    }

    public  void saveMessageLog(ErpMessageLog erpMessagelog) {
        try {
            makeLog.insertLog(erpMessagelog);
        }catch(Exception e) {
            log.error(e.getMessage(),e);
        }
    }


    class MessageLogWriter implements Runnable {
        private LinkedBlockingQueue<Object> queue;
        private boolean run = true;
        public MessageLogWriter() {
            log.debug("default constructor for spring...");
            this.queue = new LinkedBlockingQueue();
        }
        public LinkedBlockingQueue<Object> getQueue() {
            return this.queue;
        }
        public void setRun(boolean run) {
            this.run = run;
        }
        @Override
        public void run() {
            Object annex = new Object();
            while(this.run) {
                synchronized(this.getQueue()) {
                    try {
                        Object obj = this.getQueue().take();
                        if (obj != null) {
                            annex = obj;
                        }
                    } catch (InterruptedException e) {
                        log.error(e.getMessage(),e);
                    }
                }
                if (annex instanceof ErpMessageLog) {
                    saveMessageLog((ErpMessageLog)annex);
                }
            }
        }

    }
}